#
# Virtual Traces Experiment Software Distribution.
# This code is licensed under GPL v2, and is copyright (C) Jack Whitham 2008.
# See PATCH_NOTE.
#

import pickle, capture_metas

def Main():
    try:
        results = pickle.load(file("results_data"))
    except:
        results = dict()

    program_list = pickle.load(file("bench_data"))
    program_list.sort()
    for record in program_list:
        base_name = record[ 'base_name' ]
        try:
            ccm_file = file('%s_ccm.txt' % base_name, 'rt')
            result_file = file('%s_result2.txt' % base_name, 'rt')
        except IOError:
            continue

        count = 0
        for line in ccm_file:
            count += 1

        start = stop = None
        for line in result_file:
            if ( line.startswith('start: ') ):
                start = int(line.split()[ 1 ])
            elif ( line.startswith('stop: ') ):
                stop = int(line.split()[ 1 ])

        assert start != None
        assert stop != None
        assert count != 0
        results[ (base_name, None) ] = count
        results[ (base_name, capture_metas.MAX_META_INST_LENGTH) ] = (
                stop - start )

        pickle.dump(results, file("results_data", 'wb'))

if ( __name__ == "__main__" ):
    Main()

