#ifndef SYMBOLTABLE_HH
#define SYMBOLTABLE_HH

#include <map>
#include <unordered_map>
#include <string>
#include <vector>
#include "u64.hh"

class Symbol_Table
{
public:
    Symbol_Table ( FILE * nm ) ;
    virtual ~Symbol_Table () ;
    void Lookup ( FILE * outfd , ulongint pc ) ;
    ulongint Get_Data_Size () const { return data_size ; } ;
    bool Get_Record ( std::string name ,
            ulongint & address , ulongint & size ) ;

private:
    class Symbol_Record
    {
    public:
        Symbol_Record () {} ;
        virtual ~Symbol_Record () {} ;

        std::string     name ;
        ulongint        size , address ;
    } ;

    typedef std::map<ulongint, Symbol_Record *> STMap ;


    std::vector<Symbol_Record *>        all_records ;
    STMap                               table ;
    ulongint                            data_size ;
    std::unordered_map<std::string, Symbol_Record *> 
                                        reverse_table ;


} ;

#endif

